﻿#ifndef FILETHREAD_H
#define FILETHREAD_H

#if _MSC_VER >=1600

#pragma execution_character_set("utf-8")

#endif

#include <QThread>
#include "netdiskserverapitool.h"
#include "netdisksession.h"
#include "userdbsession.h"
#include "toolunit.h"

#include "UserInformation.h"
class filethread:public QThread
{
    Q_OBJECT
public:
    filethread();
    ~filethread();
signals:
    void   updatepoolloadfileprocess(const int &loadtype,
                                    const QString &fileUuid,
                                    const qint64 &loadedsize,
                                    const qint64 &totalsize,
                                    const int &ntime,
                                    const int& type,
                                    const Diskfileinformation& fileInfo);
    void   updatepoolloadfilestatus(const int &loadtype, const QString &fileuuid, const int &nstatus);
    void   stoploadfileblock(const QString& fileUuid, const qint64& fileblock);
public:
   void    addTask(const loadfiletask* task);
public:
   void    run();
public:
   void    uploadfile();
   void    downloadfile();
public:
   bool    getfilemd5(const QString& strfilepath, QString & strfilemd5);
   //上传
   int     beforecheckfileinfo();
   int     uploadblock();
   int     checkuploadwhichblock(const QString &md5, const qint64 &block, const qint64& blocksize);
   int     checksuccessuploadfile();
   //下载
   void getonefileinfo();
   void downloadblock();
   bool createTempFile();
   void getCurrentTime();
public:
   bool    m_bquit;
   int     m_nType;         // 1 上传  2 下载
   int     m_isFinish;//传输任务是否结束，1结束、传输失败
   QString m_fileType;
   QString m_fileToUuid;
   QString m_strfileuuid;
   QString m_strfilelocalpath;
   QString m_strfilecserverpath;
   QString m_strfilename;
   QString m_strfilemd5;
   qint64  m_nfilesize;
   qint64  m_uploadedSize = 0;//已上传的大小
   qint64  m_uploadedBlock = 0;//已上传到哪一块

   qint64   m_ndownloadblock; //已经下载到那个块
   netdisksession *disktool = nullptr;

   Diskfileinformation m_uploadFileInfo;//上传的文件
private:
   QString m_failureMsg;
   QString m_downloadFileMD5;
   QString m_downloadFileType;//下载文件的格式，如.zip,.txt
   QString m_downloadFileName;//下载文件的名称，不带后缀格式
   QString m_filelocaldirpath;//下载文件所在目录
   QString m_tempFilePath;//下载临时文件目录
   QString m_downloadConfigFilePath;//下载临时文件目录   
   qint64  m_downloadBlockNumber;//分段下载编号
   qint64  m_downloadBlockStart;//分段下载位置

   UserDbSession *userDBTool = nullptr;

   void fileMergeAction();
   void checkSubsectionFileAction();

};

#endif // FILETHREAD_H
